module Fedi.Helpers (
  module Export,
  module Fedi.Helpers,
) where

import Control.Monad as Export
import Control.Monad.Catch as Export (Exception, MonadThrow, throwM)
import Data.Aeson qualified as A
import Data.Aeson.Encode.Pretty qualified as AP
import Data.ByteString as Export (ByteString)
import Data.Foldable as Export
import Data.Function as Export hiding (id)
import Data.Functor as Export
import Data.Maybe as Export (fromMaybe, listToMaybe, maybeToList)
import Data.String as Export (fromString)
import Data.Text as Export (Text)
import Data.Text.Lazy qualified as TL
import Data.Text.Lazy.Encoding qualified as TL
import Data.Time as Export (UTCTime)
import Data.Traversable as Export
import GHC.Generics as Export (Generic)
import Text.Pretty.Simple qualified as PS

data Error
  = Error String
  deriving (Show, Exception)

throw :: (MonadThrow m) => String -> m a
throw = throwM . Error

pShow :: (Show a) => a -> Text
pShow = TL.toStrict . PS.pShow

pJson :: (A.ToJSON a) => a -> Text
pJson =
  TL.toStrict
    . TL.decodeUtf8
    . AP.encodePretty' AP.defConfig {AP.confIndent = AP.Spaces 2}
